/***************************************************************************
Name: JSView
Version: 1.1.2
Description: Allows you to view the source code of external js and css files
Author: Ron Beckman
Homepage: http://scorpiondb.com/firefox/extensions/jsview/
Email: scorpiondb@scorpiondb.com

Copyright (C) 2005  Ron Beckman

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

Free Software Foundation, Inc.
51 Franklin Street
Fifth Floor
Boston, MA  02110-1301
USA
***************************************************************************/





var jsvOptions = {

	framePrefHelp: function() {
		var strbdl = document.getElementById("jsview-bundle");
		var msg = strbdl.getString('jsvFrPrfHlp');
		alert(msg);
	},

	tempfileWarning: function() {
		var strbdl = document.getElementById("jsview-bundle");
		var msg = strbdl.getString('jsvTmpFiWng');
		alert(msg);
	},

	behavior: function() {
		var strbdl = document.getElementById("jsview-bundle");
		var none = strbdl.getString('jsvOpenNewWin');
		var one = strbdl.getString('jsvOpenBlur');
		var two = strbdl.getString('jsvOpenFocus');
		var three = strbdl.getString('jsvExternal');
		var attrib = document.getElementById('chooseBehavior');
		var current = attrib.value;

		if (current == none) {
			attrib.value = one;
		} else if (current == one) {
			attrib.value = two;
		} else if (current == two) {
			attrib.value = three;
		} else if (current == three || current == '') {
			attrib.value = none;
		}
	},

	onDialogLoad: function() {

		moveTo((screen.width-300)/2,(screen.height-262)/2);

		var prefs = Components.classes["@mozilla.org/preferences-service;1"].
			getService(Components.interfaces.nsIPrefService).
			getBranch("jsview.");

		var strbdl = document.getElementById("jsview-bundle");

		var checkone = document.getElementById("disableContext");
		if (prefs.prefHasUserValue("disableContext")) {
			checkone.checked = prefs.getBoolPref("disableContext");
		} else {
			checkone.checked = false;
			prefs.setBoolPref("disableContext", false);
		}

		var checktwo = document.getElementById("disableStatus");
		if (prefs.prefHasUserValue("disableStatus")) {
			checktwo.checked = prefs.getBoolPref("disableStatus");
		} else {
			checktwo.checked = false;
			prefs.setBoolPref("disableStatus", false);
		}

		var checkfour = document.getElementById("clearTemp");
		if (prefs.prefHasUserValue("clearTemp")) {
			checkfour.checked = prefs.getBoolPref("clearTemp");
		} else {
			checkfour.checked = false;
			prefs.setBoolPref("clearTemp", false);
		}

		var checkfive = document.getElementById("disableToolsOptions");
		if (prefs.prefHasUserValue("disableToolsOptions")) {
			checkfive.checked = prefs.getBoolPref("disableToolsOptions");
		} else {
			checkfive.checked = false;
			prefs.setBoolPref("disableToolsOptions", false);
		}

		var checkeight = document.getElementById("framePref");
		if (prefs.prefHasUserValue("framePref")) {
			checkeight.checked = prefs.getBoolPref("framePref");
		} else {
			checkeight.checked = false;
			prefs.setBoolPref("framePref", false);
		}

		var txtonemsg = strbdl.getString('jsvSelectApp');
		var textone = document.getElementById("applocation");
		if (prefs.prefHasUserValue("extapp")) {
			textone.value = prefs.getComplexValue('extapp', Components.interfaces.nsILocalFile).path;
		} else {
			textone.value = txtonemsg;
			textone.style.setProperty('color','red',null);
			textone.style.setProperty('font-weight','900',null);
			textone.style.setProperty('background','yellow',null);
		}

		var txttwomsg = strbdl.getString('jsvSelectLoc');
		var texttwo = document.getElementById("templocation");
		if (prefs.prefHasUserValue("temploc")) {
			texttwo.value = prefs.getComplexValue('temploc', Components.interfaces.nsILocalFile).path;
		} else {
			texttwo.value = txttwomsg;
			texttwo.style.setProperty('color','red',null);
			texttwo.style.setProperty('font-weight','900',null);
			texttwo.style.setProperty('background','yellow',null);
		}

		var txtthreemsg = strbdl.getString('jsvOpenNewWin');
		var txtthree = document.getElementById("chooseBehavior");
		if (prefs.prefHasUserValue("chooseBehavior")) {
			txtthree.value = prefs.getCharPref("chooseBehavior");
		} else {
			txtthree.value = txtthreemsg;
			prefs.setCharPref("chooseBehavior", txtthreemsg);
		}
	},

	onDialogAccept: function() {
		//get browser window
		var windowMediatorIID = Components.interfaces.nsIWindowMediator;
		var windowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(windowMediatorIID);
		var topWin = windowMediator.getMostRecentWindow("navigator:browser");

		var prefs = Components.classes["@mozilla.org/preferences-service;1"].
			getService(Components.interfaces.nsIPrefService).
			getBranch("jsview.");

		var checkone = document.getElementById("disableContext");
		var contextdiff = "";
		(checkone.checked != prefs.getBoolPref("disableContext")) ? contextdiff = "yes" : contextdiff = "no";
		prefs.setBoolPref("disableContext", checkone.checked);

		var checktwo = document.getElementById("disableStatus");
		var statusdiff = "";
		(checktwo.checked != prefs.getBoolPref("disableStatus")) ? statusdiff = "yes" : statusdiff = "no";
		prefs.setBoolPref("disableStatus", checktwo.checked);

		var checkfour = document.getElementById("clearTemp");
		prefs.setBoolPref("clearTemp", checkfour.checked);

		var checkfive = document.getElementById("disableToolsOptions");
		var toolsmenudiff = "";
		(checkfive.checked != prefs.getBoolPref("disableToolsOptions")) ? toolsmenudiff = "yes" : toolsmenudiff = "no";
		prefs.setBoolPref("disableToolsOptions", checkfive.checked);

		var checkeight = document.getElementById("framePref");
		prefs.setBoolPref("framePref", checkeight.checked);

		var txtone = document.getElementById("chooseBehavior");
		prefs.setCharPref("chooseBehavior", txtone.value);

		var contextmenu = topWin.document.getElementById('contentAreaContextMenu');
		var jscontext = topWin.document.getElementById('jsview-context-popup');
		var csscontext = topWin.document.getElementById('cssview-context-popup');
		var jscontextmenu = topWin.document.getElementById('jsview-context-menu');
		var csscontextmenu = topWin.document.getElementById('cssview-context-menu');
		var contlist = contextmenu.getAttribute('listen');
		var jscontlist = jscontext.getAttribute('listen');
		var csscontlist = csscontext.getAttribute('listen');
		if (contextdiff == "yes") {
			if (!checkone.checked && contlist == 'off' && jscontlist == 'off' && csscontlist == 'off') {
				contextmenu.addEventListener("popupshowing", topWin.jsviewContextListener, false);
				jscontext.addEventListener("popupshowing", topWin.jsviewJSContextListener, false);
				csscontext.addEventListener("popupshowing", topWin.jsviewCSSContextListener, false);
				contextmenu.setAttribute('listen','on');
				jscontext.setAttribute('listen','on');
				csscontext.setAttribute('listen','on');
			}
			if (checkone.checked && contlist == 'on' && jscontlist == 'on' && csscontlist == 'on') {
				contextmenu.removeEventListener("popupshowing", topWin.jsviewContextListener, false);
				jscontext.removeEventListener("popupshowing", topWin.jsviewJSContextListener, false);
				csscontext.removeEventListener("popupshowing", topWin.jsviewCSSContextListener, false);
				contextmenu.setAttribute('listen','off');
				jscontext.setAttribute('listen','off');
				csscontext.setAttribute('listen','off');
				jscontextmenu.setAttribute('hidden',true);
				csscontextmenu.setAttribute('hidden',true);
			}
		}


		var status = topWin.document.getElementById('jsview-status');
		var statuspopup = topWin.document.getElementById('jsview-status-popup');
		if (statusdiff == "yes") {
			if (!checktwo.checked) {
				statuspopup.addEventListener("popupshowing", topWin.jsviewStatusListener, false);
				status.setAttribute('hidden',false);
			}
			if (checktwo.checked) {
				statuspopup.removeEventListener("popupshowing", topWin.jsviewStatusListener, false);
				status.setAttribute('hidden',true);
			}
		}

		var toolsmenu = topWin.document.getElementById('jsview-options');
		if (toolsmenudiff == "yes") {
			if (!checkfive.checked) {
				toolsmenu.setAttribute('hidden',false);
			}
			if (checkfive.checked) {
				toolsmenu.setAttribute('hidden',true);
			}
		}
	},

	chooseProgram: function() {
		var strbdl = document.getElementById("jsview-bundle");
		var msgext = strbdl.getString('jsvSelectExt');
		var nsIFilePicker = Components.interfaces.nsIFilePicker;
		var fp = Components.classes["@mozilla.org/filepicker;1"]
        		.createInstance(nsIFilePicker);
		fp.init(window, msgext, nsIFilePicker.modeOpen);
		fp.appendFilter("Programs","*.exe");
		var res = fp.show();
		if (res == nsIFilePicker.returnOK) {
			var prefs = Components.classes["@mozilla.org/preferences-service;1"].
				getService(Components.interfaces.nsIPrefService).
				getBranch("jsview.");

			prefs.setComplexValue('extapp', Components.interfaces.nsILocalFile, fp.file);
			document.getElementById('applocation').value = fp.file.path;
			document.getElementById('applocation').removeAttribute('style');
		}
	},

	chooseTemp: function() {
		var strbdl = document.getElementById("jsview-bundle");
		var msgtmp = strbdl.getString('jsvSelectTmp');
		var nsIFilePicker = Components.interfaces.nsIFilePicker;
		var fp = Components.classes["@mozilla.org/filepicker;1"]
			.createInstance(nsIFilePicker);
		fp.init(window, msgtmp, nsIFilePicker.modeGetFolder);
		var res = fp.show();
		if (res == nsIFilePicker.returnOK) {
			var prefs = Components.classes["@mozilla.org/preferences-service;1"].
				getService(Components.interfaces.nsIPrefService).
				getBranch("jsview.");

			prefs.setComplexValue('temploc', Components.interfaces.nsILocalFile, fp.file);
			document.getElementById('templocation').value = fp.file.path;
			document.getElementById('templocation').removeAttribute('style');
		}
	}
};