/***************************************************************************
Name: JSView
Version: 1.1.2
Description: Allows you to view the source code of external js and css files
Author: Ron Beckman
Homepage: http://scorpiondb.com/firefox/extensions/jsview/
Email: scorpiondb@scorpiondb.com

Copyright (C) 2005  Ron Beckman

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

Free Software Foundation, Inc.
51 Franklin Street
Fifth Floor
Boston, MA  02110-1301
USA
***************************************************************************/



window.addEventListener("load", startItUp, false);
window.addEventListener("unload", removeTemp, false);

var jsviewProgress = {

  QueryInterface: function(aIID) {
    if (aIID.equals(Components.interfaces.nsIWebProgressListener)   ||
        aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
        aIID.equals(Components.interfaces.nsISupports))
      return this;
  },

  onLinkIconAvailable: function(a) { },
  onLocationChange: function(a,b,c) {
	jsviewProgress.load=a;
	jsviewProgress.pend=b;
	checkLoadStatus();
  },
  onProgressChange: function(a,b,c,d,e,f) { },
  onSecurityChange: function(a,b,c) { },
  onStateChange: function(a,b,c,d) { },
  onStatusChange: function(a,b,c,d) { }
};

function startItUp() {
  gBrowser.addProgressListener(jsviewProgress);
  jsview.jsviewInit();
}

function checkLoadStatus() {
	try {
		if (jsviewProgress.load.isLoadingDocument==true ||
		    jsviewProgress.pend.isPending()==true) {
			setTimeout(checkLoadStatus,1000);
		} else {
			jsview.jsviewOnload();
		}
	} catch(e) {
		jsview.jsviewOnload();
	}
}

var jsview = {

	jsviewMain: function(arg) {
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].
		getService(Components.interfaces.nsIPrefService).
		getBranch("jsview.");

		var windowMediatorIID = Components.interfaces.nsIWindowMediator;
		var windowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(windowMediatorIID);
		var topWin = windowMediator.getMostRecentWindow("navigator:browser");

		var ext,param;
		var behavior = prefs.getCharPref('chooseBehavior');
		var strbdl = document.getElementById('jsview-bundle');
		var one = strbdl.getString('jsvOpenBlur');
		var two = strbdl.getString('jsvOpenFocus');
		var three = strbdl.getString('jsvExternal');

		if (behavior==one) {
			ext = arg.substr(-3);
			param = arg.substr(-7);
			if (ext!='css' && ext!='.js' && param!='?jsview') arg = 'view-source:'+arg;
			topWin.getBrowser().addTab(arg+'?jsview');
		} else if (behavior==two) {
			ext = arg.substr(-3);
			param = arg.substr(-7);
			if (ext!='css' && ext!='.js' && param!='?jsview') arg = 'view-source:'+arg;
			var newTab = topWin.getBrowser().addTab(arg+'?jsview');
			topWin.getBrowser().selectedTab = newTab;
		} else if (behavior==three) {
			startProcess(arg);
		} else {
			BrowserViewSourceOfURL(arg);
		}
	},

	jsviewOpenAllJS: function() {
		var js = isJSExternal();
		var i;
		for (i=0; i<js.length; ++i) {
			setTimeout("BrowserViewSourceOfURL('"+js[i]+"')",i*500);
		}
	},

	jsviewOpenAllCSS: function() {
		var css = isCSSExternal();
		var i;
		for (i=0; i<css.length; ++i) {
			setTimeout("BrowserViewSourceOfURL('"+css[i]+"')",i*500);
		}
	},

	jsviewInit: function() {
		const prefs = Components.classes["@mozilla.org/preferences-service;1"].
		getService(Components.interfaces.nsIPrefService).
		getBranch("jsview.");

		var strbdl = document.getElementById('jsview-bundle');
		var bhvr = strbdl.getString('jsvOpenNewWin');

		if (!prefs.prefHasUserValue('chooseBehavior')) {
			prefs.setBoolPref("disableContext", false);
			prefs.setBoolPref("disableStatus", false);
			prefs.setBoolPref("clearTemp", false);
			prefs.setBoolPref("disableToolsOptions", false);
			prefs.setBoolPref("framePref", false);
			prefs.setCharPref("chooseBehavior", bhvr);
		}

		if (prefs.prefHasUserValue('activateOnclick')) {
			var aoc = prefs.getBoolPref('activateOnclick');
			if (aoc==true)
				document.getElementById('jsview-status').setAttribute('onclick','jsview.jsviewStatus();');
		}

		var toolsmenupref = prefs.getBoolPref('disableToolsOptions');
		var jsviewtoolsoptions = document.getElementById('jsview-options');

		var contextpref = prefs.getBoolPref("disableContext");
		var contextmenu = document.getElementById("contentAreaContextMenu");
		var jscontext = document.getElementById('jsview-context-popup');
		var csscontext = document.getElementById('cssview-context-popup');

		var toolbar = document.getElementById('menu_viewPopup') ||
			document.getElementById('menu_View_Popup');
		var jstoolbar = document.getElementById("jsview-toolbar-popup");
		var csstoolbar = document.getElementById("cssview-toolbar-popup");

		var button = document.getElementById('jsview-button');
		var buttonpopup = document.getElementById('jsview-button-popup');

		var statuspref = prefs.getBoolPref("disableStatus");
		var status = document.getElementById('jsview-status');
		var statuspopup = document.getElementById('jsview-status-popup');

		if (contextmenu) {
			contextmenu.addEventListener("popupshowing", extEditorContextListener, false);
		}

		if (contextmenu && jscontext && csscontext && contextpref == false) {
			contextmenu.addEventListener("popupshowing", jsviewContextListener, false);
			jscontext.addEventListener("popupshowing", jsviewJSContextListener, false);
			csscontext.addEventListener("popupshowing", jsviewCSSContextListener, false);
			contextmenu.setAttribute('listen','on');
			jscontext.setAttribute('listen','on');
			csscontext.setAttribute('listen','on');
		} else {
			document.getElementById('jsview-context-menu').setAttribute('hidden',true);
			document.getElementById('cssview-context-menu').setAttribute('hidden',true);
			contextmenu.setAttribute('listen','off');
			jscontext.setAttribute('listen','off');
			csscontext.setAttribute('listen','off');
		}

		if (toolbar && jstoolbar && csstoolbar) {
			toolbar.addEventListener("popupshowing", jsviewToolbarListener, false);
			jstoolbar.addEventListener("popupshowing", jsviewJSToolbarListener, false);
			csstoolbar.addEventListener("popupshowing", jsviewCSSToolbarListener,false);
		} else {
			document.getElementById('jsview-toolbar-menu').setAttribute('hidden',true);
			document.getElementById('cssview-toolbar-menu').setAttribute('hidden',true);
		}

		if (buttonpopup) {
			buttonpopup.addEventListener("popupshowing", jsviewButtonListener, false);
		}

		if (statuspopup && statuspref==false) {
			statuspopup.addEventListener("popupshowing", jsviewStatusListener, false);
			statuspopup.setAttribute('listen','on');
		} else {
			status.setAttribute('hidden',true);
			statuspopup.setAttribute('listen','off');
		}

		if (jsviewtoolsoptions && toolsmenupref==false) {
			jsviewtoolsoptions.setAttribute('hidden',false);
		} else {
			jsviewtoolsoptions.setAttribute('hidden',true);
		}
	},

	extEditorContext: function() {
		var loc = window.content.document.location.href.substr(-7);
		if (loc=='?jsview') {
			document.getElementById('jsview-editor').setAttribute('hidden',false);
		} else {
			document.getElementById('jsview-editor').setAttribute('hidden',true);
		}
	},

	jsviewContext: function() {
		var strbdl = document.getElementById('jsview-bundle');
		var jsmsg = strbdl.getString('jsvViewExtJs');
		var cssmsg = strbdl.getString('jsvViewExtCss');

		var loc = window.content.document.location.href.substr(-7);
		if (loc=='?jsview') {
			document.getElementById('jsview-editor').setAttribute('hidden',false);
		} else {
			document.getElementById('jsview-editor').setAttribute('hidden',true);
		}

		var js = isJSExternal();
		var css = isCSSExternal();
		var jscontext = document.getElementById('jsview-context-menu');
		var csscontext = document.getElementById('cssview-context-menu');

		if (js.length > 0 && !gContextMenu.onLink) {
			jscontext.setAttribute('hidden',false);
			jscontext.setAttribute('label',jsmsg+" (" +js.length+ ")");
		} else {
			jscontext.setAttribute('hidden',true);
		}

		if (css.length > 0 && !gContextMenu.onLink) {
			csscontext.setAttribute('hidden',false);
			csscontext.setAttribute('label',cssmsg+" (" +css.length+ ")");
		} else {
			csscontext.setAttribute('hidden',true);
		}
	},

	jsviewJSContext: function() {
		var strbdl = document.getElementById('jsview-bundle');
		var jsmsg = strbdl.getString('jsvViewAllJs');
		var done = strbdl.getString('jsvDone');
		var jsnf = strbdl.getString('jsvJsNF');

		var js = isJSExternal();
		var jscontext = document.getElementById('jsview-context-popup');

		while (jscontext.firstChild) {
			jscontext.removeChild(jscontext.firstChild);
		}

		if (js.length > 0) {
			var name = jsmsg;
			var temp = document.createElement('menuitem');
			temp.setAttribute('id','context-viewalljs');
			temp.setAttribute('label',name);
			temp.setAttribute('oncommand',"jsview.jsviewOpenAllJS()");
			temp.setAttribute('image','chrome://jsview/skin/js.gif');
			temp.setAttribute('tooltiptext',name);
			temp.setAttribute('style','font-weight:900;');
			jscontext.appendChild(temp);

			var i;
			for (i=0; i<js.length; ++i) {
				var name = js[i].substr(js[i].lastIndexOf('/')+1);
				var temp = document.createElement('menuitem');
				temp.setAttribute('id',name+i);
				temp.setAttribute('label',name);
				temp.setAttribute('oncommand',"jsview.jsviewMain('"+js[i]+"')");
				temp.setAttribute('image','chrome://jsview/skin/js.gif');
				temp.setAttribute('tooltiptext',js[i]);
				temp.setAttribute('onmouseover',"document.getElementById('statusbar-display').label='"+js[i]+"';");
				temp.setAttribute('onmouseout',"document.getElementById('statusbar-display').label='"+done+"';");
				jscontext.appendChild(temp);
			}
		} else {
			var temp = document.createElement('menuitem');
			temp.setAttribute('id','jsview-context-item-nf');
			temp.setAttribute('label',jsnf);
			temp.setAttribute('image','chrome://jsview/skin/none.gif');
			temp.setAttribute('tooltiptext',jsnf);
			temp.setAttribute('disabled','true');
			jscontext.appendChild(temp);
		}
	},

	jsviewCSSContext: function () {
		var strbdl = document.getElementById('jsview-bundle');
		var cssmsg = strbdl.getString('jsvViewAllCss');
		var done = strbdl.getString('jsvDone');
		var cssnf = strbdl.getString('jsvCssNF');

		var css = isCSSExternal();
		var csscontext = document.getElementById('cssview-context-popup');

		while (csscontext.firstChild) {
			csscontext.removeChild(csscontext.firstChild);
		}

		if (css.length > 0) {
			var name = cssmsg;
			var temp = document.createElement('menuitem');
			temp.setAttribute('id','context-viewallcss');
			temp.setAttribute('label',name);
			temp.setAttribute('oncommand',"jsview.jsviewOpenAllCSS()");
			temp.setAttribute('image','chrome://jsview/skin/css.gif');
			temp.setAttribute('tooltiptext',name);
			temp.setAttribute('style','font-weight:900;');
			csscontext.appendChild(temp);

			var i;
			for (i=0; i<css.length; ++i) {
				var name = css[i].substr(css[i].lastIndexOf('/')+1);
				var temp = document.createElement('menuitem');
				temp.setAttribute('id',name+i);
				temp.setAttribute('label',name);
				temp.setAttribute('oncommand',"jsview.jsviewMain('"+css[i]+"')");
				temp.setAttribute('image','chrome://jsview/skin/css.gif');
				temp.setAttribute('tooltiptext',css[i]);
				temp.setAttribute('onmouseover',"document.getElementById('statusbar-display').label='"+css[i]+"';");
				temp.setAttribute('onmouseout',"document.getElementById('statusbar-display').label='"+done+"';");
				csscontext.appendChild(temp);
			}
		} else {
			var temp = document.createElement('menuitem');
			temp.setAttribute('id','cssview-context-item-nf');
			temp.setAttribute('label',cssnf);
			temp.setAttribute('image','chrome://jsview/skin/none.gif');
			temp.setAttribute('tooltiptext',cssnf);
			temp.setAttribute('disabled','true');
			csscontext.appendChild(temp);
		}
	},

	jsviewToolbar: function () {
		var strbdl = document.getElementById('jsview-bundle');
		var jsmsg = strbdl.getString('jsvExtJs');
		var cssmsg = strbdl.getString('jsvExtCss');

		var js = isJSExternal();
		var css = isCSSExternal();
		var jstoolbar = document.getElementById('jsview-toolbar-menu');
		var csstoolbar = document.getElementById('cssview-toolbar-menu');

		if (js.length > 0) {
			jstoolbar.setAttribute('hidden',false);
			jstoolbar.setAttribute('label',jsmsg+" (" +js.length+ ")");
		} else {
			jstoolbar.setAttribute('hidden',true);
		}

		if (css.length > 0) {
			csstoolbar.setAttribute('hidden',false);
			csstoolbar.setAttribute('label',cssmsg+" (" +css.length+ ")");
		} else {
			csstoolbar.setAttribute('hidden',true);
		}
	},

	jsviewJSToolbar: function() {
		var strbdl = document.getElementById('jsview-bundle');
		var jsmsg = strbdl.getString('jsvViewAllJs');
		var jsnf = strbdl.getString('jsvJsNF');

		var js = isJSExternal();
		var jstools = document.getElementById('jsview-toolbar-popup');

		while (jstools.firstChild) {
			jstools.removeChild(jstools.firstChild);
		}

		if (js.length > 0) {
			var name = jsmsg;
			var temp = document.createElement('menuitem');
			temp.setAttribute('id','toolbar-viewalljs');
			temp.setAttribute('label',name);
			temp.setAttribute('oncommand',"jsview.jsviewOpenAllJS()");
			temp.setAttribute('image','chrome://jsview/skin/js.gif');
			temp.setAttribute('tooltiptext',name);
			temp.setAttribute('style','font-weight:900;');
			jstools.appendChild(temp);

			var i;
			for (i=0; i<js.length; ++i) {
				var name = js[i].substr(js[i].lastIndexOf('/')+1);
				var temp = document.createElement('menuitem');
				temp.setAttribute('id',name+i);
				temp.setAttribute('label',name);
				temp.setAttribute('oncommand',"jsview.jsviewMain('"+js[i]+"')");
				temp.setAttribute('image','chrome://jsview/skin/js.gif');
				temp.setAttribute('tooltiptext',js[i]);
				temp.setAttribute('statustext',js[i]);
				jstools.appendChild(temp);
			}
		} else {
			var temp = document.createElement('menuitem');
			temp.setAttribute('id','jsview-toolbar-item-nf');
			temp.setAttribute('label',jsnf);
			temp.setAttribute('image','chrome://jsview/skin/none.gif');
			temp.setAttribute('tooltiptext',jsnf);
			temp.setAttribute('disabled','true');
			jstools.appendChild(temp);
		}
	},

	jsviewCSSToolbar: function() {
		var strbdl = document.getElementById('jsview-bundle');
		var cssmsg = strbdl.getString('jsvViewAllCss');
		var cssnf = strbdl.getString('jsvCssNF');

		var css = isCSSExternal();
		var csstools = document.getElementById('cssview-toolbar-popup');

		while (csstools.firstChild) {
			csstools.removeChild(csstools.firstChild);
		}

		if (css.length > 0) {
			var name = cssmsg;
			var temp = document.createElement('menuitem');
			temp.setAttribute('id','toolbar-viewallcss');
			temp.setAttribute('label',name);
			temp.setAttribute('oncommand',"jsview.jsviewOpenAllCSS()");
			temp.setAttribute('image','chrome://jsview/skin/css.gif');
			temp.setAttribute('tooltiptext',name);
			temp.setAttribute('style','font-weight:900;');
			csstools.appendChild(temp);

			var i;
			for (i=0; i<css.length; ++i) {
				var name = css[i].substr(css[i].lastIndexOf('/')+1);
				var temp = document.createElement('menuitem');
				temp.setAttribute('id',name+i);
				temp.setAttribute('label',name);
				temp.setAttribute('oncommand',"jsview.jsviewMain('"+css[i]+"')");
				temp.setAttribute('image','chrome://jsview/skin/css.gif');
				temp.setAttribute('tooltiptext',css[i]);
				temp.setAttribute('statustext',css[i]);
				csstools.appendChild(temp);
			}
		} else {
			var temp = document.createElement('menuitem');
			temp.setAttribute('id','cssview-toolbar-item-nf');
			temp.setAttribute('label',cssnf);
			temp.setAttribute('image','chrome://jsview/skin/none.gif');
			temp.setAttribute('tooltiptext',cssnf);
			temp.setAttribute('disabled','true');
			csstools.appendChild(temp);
		}
	},

	jsviewButton: function() {
		var strbdl = document.getElementById('jsview-bundle');
		var cssmsg = strbdl.getString('jsvViewAllCss');
		var done = strbdl.getString('jsvDone');
		var cssnf = strbdl.getString('jsvCssNF');
		var jsmsg = strbdl.getString('jsvViewAllJs');
		var jsnf = strbdl.getString('jsvJsNF');

		var js = isJSExternal();
		var css = isCSSExternal();
		var jsbutton = document.getElementById('jsview-button-popup');

		while (jsbutton.firstChild) {
			jsbutton.removeChild(jsbutton.firstChild);
		}

		if (js.length > 0) {
			var name = jsmsg;
			var temp = document.createElement('menuitem');
			temp.setAttribute('id','button-viewalljs');
			temp.setAttribute('label',name);
			temp.setAttribute('oncommand',"jsview.jsviewOpenAllJS()");
			temp.setAttribute('image','chrome://jsview/skin/js.gif');
			temp.setAttribute('tooltiptext',name);
			temp.setAttribute('style','font-weight:900;');
			jsbutton.appendChild(temp);

			var i;
			for (i=0; i<js.length; ++i) {
				var name = js[i].substr(js[i].lastIndexOf('/')+1);
				var temp = document.createElement('menuitem');
				temp.setAttribute('id',name+i);
				temp.setAttribute('label',name);
				temp.setAttribute('oncommand',"jsview.jsviewMain('"+js[i]+"')");
				temp.setAttribute('image','chrome://jsview/skin/js.gif');
				temp.setAttribute('tooltiptext',js[i]);
				temp.setAttribute('onmouseover',"document.getElementById('statusbar-display').label='"+js[i]+"';");
				temp.setAttribute('onmouseout',"document.getElementById('statusbar-display').label='"+done+"';");
				jsbutton.appendChild(temp);
			}
		} else {
			var temp = document.createElement('menuitem');
			temp.setAttribute('id','jsview-button-item-nf');
			temp.setAttribute('label',jsnf);
			temp.setAttribute('image','chrome://jsview/skin/none.gif');
			temp.setAttribute('tooltiptext',jsnf);
			temp.setAttribute('disabled','true');
			jsbutton.appendChild(temp);
		}

		var temp = document.createElement('menuseparator');
		jsbutton.appendChild(temp);

		if (css.length > 0) {
			var name = cssmsg;
			var temp = document.createElement('menuitem');
			temp.setAttribute('id','button-viewallcss');
			temp.setAttribute('label',name);
			temp.setAttribute('oncommand',"jsview.jsviewOpenAllCSS()");
			temp.setAttribute('image','chrome://jsview/skin/css.gif');
			temp.setAttribute('tooltiptext',name);
			temp.setAttribute('style','font-weight:900;');
			jsbutton.appendChild(temp);

			var i;
			for (i=0; i<css.length; ++i) {
				var name = css[i].substr(css[i].lastIndexOf('/')+1);
				var temp = document.createElement('menuitem');
				temp.setAttribute('id',name+i);
				temp.setAttribute('label',name);
				temp.setAttribute('oncommand',"jsview.jsviewMain('"+css[i]+"')");
				temp.setAttribute('image','chrome://jsview/skin/css.gif');
				temp.setAttribute('tooltiptext',css[i]);
				temp.setAttribute('onmouseover',"document.getElementById('statusbar-display').label='"+css[i]+"';");
				temp.setAttribute('onmouseout',"document.getElementById('statusbar-display').label='"+done+"';");
				jsbutton.appendChild(temp);
			}
		} else {
			var temp = document.createElement('menuitem');
			temp.setAttribute('id','cssview-button-item-nf');
			temp.setAttribute('label',cssnf);
			temp.setAttribute('image','chrome://jsview/skin/none.gif');
			temp.setAttribute('tooltiptext',cssnf);
			temp.setAttribute('disabled','true');
			jsbutton.appendChild(temp);
		}
	},

	jsviewStatus: function() {
		var strbdl = document.getElementById('jsview-bundle');
		var cssmsg = strbdl.getString('jsvViewAllCss');
		var done = strbdl.getString('jsvDone');
		var cssnf = strbdl.getString('jsvCssNF');
		var jsmsg = strbdl.getString('jsvViewAllJs');
		var jsnf = strbdl.getString('jsvJsNF');

		var js = isJSExternal();
		var css = isCSSExternal();
		var jsstatus = document.getElementById('jsview-status-popup');

		while (jsstatus.firstChild) {
			jsstatus.removeChild(jsstatus.firstChild);
		}

		if (js.length > 0) {
			var name = jsmsg;
			var temp = document.createElement('menuitem');
			temp.setAttribute('id','status-viewalljs');
			temp.setAttribute('label',name);
			temp.setAttribute('oncommand',"jsview.jsviewOpenAllJS()");
			temp.setAttribute('image','chrome://jsview/skin/js.gif');
			temp.setAttribute('tooltiptext',name);
			temp.setAttribute('style','font-weight:900;');
			jsstatus.appendChild(temp);

			var i;
			for (i=0; i<js.length; ++i) {
				var name = js[i].substr(js[i].lastIndexOf('/')+1);
				var sbar = document.getElementById('statusbar-display');
				var temp = document.createElement('menuitem');
				temp.setAttribute('id',name+i);
				temp.setAttribute('label',name);
				temp.setAttribute('oncommand',"jsview.jsviewMain('"+js[i]+"')");
				temp.setAttribute('image','chrome://jsview/skin/js.gif');
				temp.setAttribute('tooltiptext',js[i]);
				temp.setAttribute('onmouseover',"document.getElementById('statusbar-display').label='"+js[i]+"';");
				temp.setAttribute('onmouseout',"document.getElementById('statusbar-display').label='"+done+"';");
				jsstatus.appendChild(temp);
			}
		} else {
			var temp = document.createElement('menuitem');
			temp.setAttribute('id','jsview-status-item-nf');
			temp.setAttribute('label',jsnf);
			temp.setAttribute('image','chrome://jsview/skin/none.gif');
			temp.setAttribute('tooltiptext',jsnf);
			temp.setAttribute('disabled','true');
			jsstatus.appendChild(temp);
		}

		var temp = document.createElement('menuseparator');
		jsstatus.appendChild(temp);

		if (css.length > 0) {
			var name = cssmsg;
			var temp = document.createElement('menuitem');
			temp.setAttribute('id','status-viewallcss');
			temp.setAttribute('label',name);
			temp.setAttribute('oncommand',"jsview.jsviewOpenAllCSS()");
			temp.setAttribute('image','chrome://jsview/skin/css.gif');
			temp.setAttribute('tooltiptext',name);
			temp.setAttribute('style','font-weight:900;');
			jsstatus.appendChild(temp);

			var i;
			for (i=0; i<css.length; ++i) {
				var name = css[i].substr(css[i].lastIndexOf('/')+1);
				var temp = document.createElement('menuitem');
				temp.setAttribute('id',name+i);
				temp.setAttribute('label',name);
				temp.setAttribute('oncommand',"jsview.jsviewMain('"+css[i]+"')");
				temp.setAttribute('image','chrome://jsview/skin/css.gif');
				temp.setAttribute('tooltiptext',css[i]);
				temp.setAttribute('onmouseover',"document.getElementById('statusbar-display').label='"+css[i]+"';");
				temp.setAttribute('onmouseout',"document.getElementById('statusbar-display').label='"+done+"';");
				jsstatus.appendChild(temp);
			}
		} else {
			var temp = document.createElement('menuitem');
			temp.setAttribute('id','cssview-status-item-nf');
			temp.setAttribute('label',cssnf);
			temp.setAttribute('image','chrome://jsview/skin/none.gif');
			temp.setAttribute('tooltiptext',cssnf);
			temp.setAttribute('disabled','true');
			jsstatus.appendChild(temp);
		}
	},

	jsviewOnload: function() {
		var strbdl = document.getElementById('jsview-bundle');
		var jsmsg = strbdl.getString('jsvExtJs');
		var cssmsg = strbdl.getString('jsvExtCss');
		var nf = strbdl.getString('jsvNF');

		var button = document.getElementById('jsview-button');
		var status = document.getElementById('jsview-status');

		try {
			var js = isJSExternal();
			var css = isCSSExternal();
		} catch(e) { }

		if (button) {
			if (js.length > 0 && css.length < 1) {
				button.setAttribute('image',"chrome://jsview/skin/js.gif");
				button.setAttribute('tooltiptext',jsmsg+" (" +js.length+ ")");
			} else if (css.length > 0 && js.length < 1) {
				button.setAttribute('image',"chrome://jsview/skin/css.gif");
				button.setAttribute('tooltiptext',cssmsg+" (" +css.length+ ")");
			} else if (js.length > 0 && css.length > 0) {
				button.setAttribute('image',"chrome://jsview/skin/both.gif");
				button.setAttribute('tooltiptext',"JS (" +js.length+ ")  CSS (" +css.length+ ")");
			} else {
				button.setAttribute('image',"chrome://jsview/skin/none.gif");
				button.setAttribute('tooltiptext',nf);
			}
		}

		if (status && status.hidden==false) {
			if (js.length > 0 && css.length < 1) {
				status.setAttribute('src',"chrome://jsview/skin/js.gif");
				status.setAttribute('tooltiptext',jsmsg+" (" +js.length+ ")");
			} else if (css.length > 0 && js.length < 1) {
				status.setAttribute('src',"chrome://jsview/skin/css.gif");
				status.setAttribute('tooltiptext',cssmsg+" (" +css.length+ ")");
			} else if (js.length > 0 && css.length > 0) {
				status.setAttribute('src',"chrome://jsview/skin/both.gif");
				status.setAttribute('tooltiptext',"JS (" +js.length+ ")  CSS (" +css.length+ ")");
			} else {
				status.setAttribute('src',"chrome://jsview/skin/none.gif");
				status.setAttribute('tooltiptext',nf);
			}
		}
	}

};

function extEditorContextListener(aEvent) {
	return(jsview.extEditorContext(aEvent));
}

function jsviewContextListener(aEvent) {
	return(jsview.jsviewContext(aEvent));
}

function jsviewJSContextListener(aEvent) {
	return(jsview.jsviewJSContext(aEvent));
}

function jsviewCSSContextListener(aEvent) {
	return(jsview.jsviewCSSContext(aEvent));
}

function jsviewToolbarListener(aEvent) {
	return(jsview.jsviewToolbar(aEvent));
}

function jsviewJSToolbarListener(aEvent) {
	return(jsview.jsviewJSToolbar(aEvent));
}

function jsviewCSSToolbarListener(aEvent) {
	return(jsview.jsviewCSSToolbar(aEvent));
}

function jsviewButtonListener(aEvent) {
	return(jsview.jsviewButton(aEvent));
}

function jsviewStatusListener(aEvent) {
	return(jsview.jsviewStatus(aEvent));
}

function isJSExternal() {
	var loc = window.content.document.location.href;
	var scriptarray = new Array();
	var j,i,m;

	var allscripts = window.content.document.getElementsByTagName('script');
	if (allscripts[0]) {
		for (i=0; i<allscripts.length; ++i) {
			if (allscripts[i].src && allscripts[i].src!=loc) {
				scriptarray.push(allscripts[i].src);
			}
		}
	}

	var pages = window.content.parent.frames;
	if (pages.length > 0) {
		for (m=0; m<pages.length; ++m) {
			var allscripts = pages[m].document.getElementsByTagName('script');
			if (allscripts[0]) {
				for (i=0; i<allscripts.length; ++i) {
					if (allscripts[i].src && allscripts[i].src!=loc) {
						scriptarray.push(allscripts[i].src);
					}
				}
			}
		}
	}

	//check for duplicate entries and remove them
	scriptarray.sort();
	for (i=0; i<scriptarray.length-1; ++i) {
		while (scriptarray[i]==scriptarray[i+1]) {
			scriptarray.splice(i,1);
		}
	}

	return scriptarray;
}


function isCSSExternal() {
	var loc = window.content.document.location.href;
	var cssarray = new Array();
	var j,i,m;

	var sheets = window.content.document.styleSheets;
	if (sheets.length > 0) {
		for (i=0; i<sheets.length; ++i) {
			if (sheets[i].href && sheets[i].href!=loc) {
				cssarray.push(sheets[i].href);
			}
			cssarray = cssarray.concat(importedCSS(sheets[i]));
		}
	}

	var pages = window.content.parent.frames;
	if (pages.length > 0) {
		for (m=0; m<pages.length; ++m) {
			var sheets = pages[m].document.styleSheets;
			if (sheets.length > 0) {
				for (i=0; i<sheets.length; ++i) {
					if (sheets[i].href && sheets[i].href!=loc) {
						cssarray.push(sheets[i].href);
					}
					cssarray = cssarray.concat(importedCSS(sheets[i]));
				}
			}
		}
	}

	//check for duplicate entries and remove them
	cssarray.sort();
	for (i=0; i<cssarray.length-1; ++i) {
		while (cssarray[i]==cssarray[i+1]) {
			cssarray.splice(i,1);
		}
	}

	return cssarray;
}


function importedCSS(css) {
	var j;
	var cssarray = [];
	var rules = css.cssRules;
	for (j=0; j<rules.length; ++j) {
		if (rules[j].type==3) {
			cssarray.push(rules[j].styleSheet.href);
			cssarray = cssarray.concat(importedCSS(rules[j].styleSheet));
		} else { break; }
	}
	return cssarray;
}


function startProcess(url) {
	const prefs = Components.classes["@mozilla.org/preferences-service;1"].
	getService(Components.interfaces.nsIPrefService).
	getBranch('jsview.');

	if (!prefs.prefHasUserValue('extapp')) {
		var obj_Program = chooseProgram();
		if (obj_Program==false) { return false; }
	} else {
		var obj_Program = prefs.getComplexValue('extapp', Components.interfaces.nsILocalFile);
	}

	//initialize process
	var obj_Process = Components.classes["@mozilla.org/process/util;1"].
		createInstance(Components.interfaces.nsIProcess);
	obj_Process.init(obj_Program);

	//remove jsview parameter
	if (url.substr(-7)=='?jsview') {
		url = url.substr(0,url.search(/\?jsview/));
	}

	//create temporary file
	var request=new XMLHttpRequest();
	request.open("GET",url,false);
	request.send(null);
	var filename = [writeFile(request.responseText,url)];
	if (filename[0]==false) { return false; }

	//open external editor
	obj_Process.run(false, filename, 1);
	return false;
}

function writeFile(sFileContent,name) {
	const prefs = Components.classes["@mozilla.org/preferences-service;1"].
	getService(Components.interfaces.nsIPrefService).
	getBranch('jsview.');

	if (!prefs.prefHasUserValue('temploc')) {
		var obj_Temp = chooseTemp();
		if (obj_Temp==false) { return false; }
	} else {
		var obj_Temp = prefs.getComplexValue('temploc', Components.interfaces.nsILocalFile);
	}

	var filename = name.substr(name.lastIndexOf('/'));
	filename = filename.replace(/[~!@#$%^&*()_+|`\-=\\\[\];',/{}:"<>? ]/g,"");
	if (filename.length<1) filename = 'index.htm';
	obj_Temp.append(filename);

	var strm = Components.classes["@mozilla.org/network/file-output-stream;1"].
		createInstance(Components.interfaces.nsIFileOutputStream);
	strm.QueryInterface(Components.interfaces.nsIOutputStream);
	strm.QueryInterface(Components.interfaces.nsISeekableStream);
	strm.init(obj_Temp, 0x04 | 0x08, 420, 0);
	strm.write(sFileContent, sFileContent.length);
	strm.flush();
	strm.close();
	return obj_Temp.path;
}

function chooseProgram() {
	var strbdl = document.getElementById('jsview-bundle');
	var msg = strbdl.getString('jsvSelectExt');

	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"]
        	.createInstance(nsIFilePicker);
	fp.init(window, msg, nsIFilePicker.modeOpen);
	fp.appendFilter("Programs","*.exe");
	var res = fp.show();
	if (res == nsIFilePicker.returnOK) {
		const prefs = Components.classes["@mozilla.org/preferences-service;1"].
		getService(Components.interfaces.nsIPrefService).
		getBranch("jsview.");

		prefs.setComplexValue('extapp', Components.interfaces.nsILocalFile, fp.file);
		return fp.file;
	} else {
		return false;
	}
}

function chooseTemp() {
	var strbdl = document.getElementById('jsview-bundle');
	var msg = strbdl.getString('jsvSelectTmp');

	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"]
		.createInstance(nsIFilePicker);
	fp.init(window, msg, nsIFilePicker.modeGetFolder);
	var res = fp.show();
	if (res == nsIFilePicker.returnOK) {
		const prefs = Components.classes["@mozilla.org/preferences-service;1"].
		getService(Components.interfaces.nsIPrefService).
		getBranch("jsview.");

		prefs.setComplexValue('temploc', Components.interfaces.nsILocalFile, fp.file);
		return fp.file;
	} else {
		return false;
	}
}

function removeTemp() {
	const prefs = Components.classes["@mozilla.org/preferences-service;1"].
		getService(Components.interfaces.nsIPrefService).
		getBranch("jsview.");

	if (prefs.prefHasUserValue('temploc') && prefs.getBoolPref('clearTemp')==true) {
		var obj_Temp = prefs.getComplexValue('temploc', Components.interfaces.nsILocalFile);

		var filesArray = [];
		var filesEnum = obj_Temp.directoryEntries;
		while (filesEnum.hasMoreElements()) {
			var file = filesEnum.getNext();
			file.QueryInterface(Components.interfaces.nsIFile);
			filesArray.push(file);
		}

		var i;
		for (i=0; i<filesArray.length; ++i) {
			//var filepath = filesArray[i].path;
			//var fileext = filepath.substr(filepath.lastIndexOf('\.')+1);
			//if (fileext=='js' || fileext=='css') {
				filesArray[i].remove(false);
			//}
		}
	}
}